/*****************************************************************************

 DIMIN Winamp HotKeys plug-in

 CLASS IMPLEMENTATION

 Programmer: Dima V. Fedorov <mailto:dima@dimin.net> <http://www.dimin.net/>

 History:
   08/27/2001 00:00:00 - First creation
   09/30/2001 00:00:00 - WM_APPCOMMAND support added
   06/20/2002 20:37:46 - un and reload hotkeys calling configuration app
   02/21/2004 00:21:00 - Changes in config, here just changed ini file name
   03/25/2004 18:39:00 - Dimin defined functions support

 Ver : 6
*****************************************************************************/


#include <windows.h>

#include "gen.h"
#include "winuser_2k.h"
#include "dim_winamp_funcs.h"
#include "winamp.h"

#define uint unsigned int

BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

#define DIMIN_VERSION "0.6"

int id_play=0xC000;
int vk_play=179;

int id_keys[256];
int vk_keys[256];
int commands[256];

int keys_count=0;


void config();
void quit();
int init();
void config_read();
char szAppName[] = "DIMIN HotKeys";

winampGeneralPurposePlugin plugin =
{
	GPPHDR_VER,
	"",
	init,
	config,
	quit,
};

//****************************************************************************
// WIN API SUPPORT FUNCTIONS
//****************************************************************************
void ProcessMessage()
{
  MSG msg;

  if ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) == TRUE)
  {
    if (msg.message != WM_QUIT)
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }
}

void runConfWaitExit(char *cnf_file)
{
  SECURITY_ATTRIBUTES sec;
  STARTUPINFO start;
  PROCESS_INFORMATION pinfo;
  DWORD waitresult;
  DWORD exitcode;

  memset(&start, 0, sizeof(STARTUPINFO));
  start.cb = sizeof(start);
  start.wShowWindow = SW_SHOWDEFAULT;
  sec.nLength = sizeof(sec);
  sec.lpSecurityDescriptor = NULL;
  sec.bInheritHandle = TRUE;
  
  if (CreateProcess(cnf_file, NULL, &sec, &sec, TRUE, 
                    0, NULL, NULL,  &start, &pinfo) != TRUE) return;
  
  do
  {
    ProcessMessage();
    waitresult = WaitForSingleObject(pinfo.hProcess, 10);
  }
  while (waitresult == WAIT_TIMEOUT);

  if (waitresult == WAIT_FAILED) return;

  //At this point the object is signaled, abandoned or done
  GetExitCodeProcess(pinfo.hProcess, &exitcode);
  CloseHandle(pinfo.hProcess);
}

//****************************************************************************
// REG/UNREG HOT KEYS WITH WINDOWS
//****************************************************************************
void regAllHotKeys()
{
  int i;
  char num[10];
  
  id_play = GlobalAddAtom("PLAY");
  RegisterHotKey(plugin.hwndParent, id_play, 0, vk_play);

  for (i=0; i<keys_count; i++)
  {
    wsprintf(num, "KEY_ID%d", i);
    id_keys[i] = GlobalAddAtom(num);    
    RegisterHotKey(plugin.hwndParent, id_keys[i], 0, vk_keys[i]);
  }
  UnregisterHotKey(plugin.hwndParent, id_keys[i]);
}

void unRegAllHotKeys()
{
  int i;
  UnregisterHotKey(plugin.hwndParent, id_play);
  for (i=0; i<keys_count; i++) UnregisterHotKey(plugin.hwndParent, id_keys[i]);
}

//****************************************************************************
// READ CONFIG FILE
//****************************************************************************
void config_read()
{
  int i; 
  char ini_file[MAX_PATH], key_name[32], *p;
  //char about[255];

	GetModuleFileName(plugin.hDllInstance,ini_file,sizeof(ini_file));
	p=ini_file+lstrlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	lstrcat(ini_file,"gen_DiminHotkeys\\gen_DiminHotkeys.ini");

	keys_count = GetPrivateProfileInt("Options", "NumKeys", keys_count, ini_file);
  if (keys_count > 255) keys_count = 255;
  if (keys_count < 0) keys_count = 0;

  vk_play = GetPrivateProfileInt("Options", "Play", vk_play, ini_file);
  
  for (i=0; i<keys_count; i++)
  {
	  wsprintf(key_name, "KeyVK%d", i);
    vk_keys[i] = GetPrivateProfileInt("Options", key_name, vk_keys[i], ini_file);

	  wsprintf(key_name, "Command%d", i);
    commands[i] = GetPrivateProfileInt("Options", key_name, commands[i], ini_file);
  }
}

//****************************************************************************
// PLUG-IN EXPORTED FUNCTIONS
//****************************************************************************
void config()
{
  char cnf_file[MAX_PATH], *p;
	
  unRegAllHotKeys();
  
  // *** now run the conf app 
  // get the conf app path
  GetModuleFileName(plugin.hDllInstance, cnf_file, sizeof(cnf_file));
	p = cnf_file+lstrlen(cnf_file);
	while (p >= cnf_file && *p != '\\') p--;
	if (++p >= cnf_file) *p = 0;
	lstrcat(cnf_file, "gen_DiminHotkeys\\DiminHotkeysConf.exe");
  // actually run conf app
  runConfWaitExit(cnf_file);

  // *** reload hotkeys
  config_read();
  regAllHotKeys();
}

void quit()
{
  unRegAllHotKeys();
}

void multipleCall(uint ni, HWND hwnd, uint cmd)
{
  uint i;
  for (i=0; i<ni; i++)
    SendMessage(hwnd, WM_COMMAND, cmd, 0); 
}

void *lpWndProcOld;
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  int ret, i;
  short cmd;
  BOOL Result=FALSE;

  // *** REGISTERED HOTKEY CALL ****************************************
  if (message == WM_HOTKEY)
	{
    if (LOWORD(wParam) == id_play)
    {
      ret = SendMessage(hwnd, WM_USER, 0, 104);
      if (ret == 1) SendMessage(hwnd, WM_COMMAND, 40046, 0);
      else SendMessage(hwnd, WM_COMMAND, 40045, 0);
    }

    for (i=0; i<keys_count; i++)
      if (LOWORD(wParam) == id_keys[i])
        if (commands[i] >= 40000) // direct call
          SendMessage(hwnd, WM_COMMAND, commands[i], 0);
        else // now if some not winamp defined command, let's process it
        {
          // Raise volume by 5%
          if (commands[i] == DIM_WINAMP_VOLUMEUP_5P)    multipleCall(5,  hwnd, WINAMP_VOLUMEUP);

          // Lower volume by 5%
          if (commands[i] == DIM_WINAMP_VOLUMEDOWN_5P)  multipleCall(5,  hwnd, WINAMP_VOLUMEDOWN);

          // Raise volume by 10%
          if (commands[i] == DIM_WINAMP_VOLUMEUP_10P)   multipleCall(10, hwnd, WINAMP_VOLUMEUP);

          // Lower volume by 10%
          if (commands[i] == DIM_WINAMP_VOLUMEDOWN_10P) multipleCall(10, hwnd, WINAMP_VOLUMEDOWN);
        }
  }

  // *** WM_APPCOMMAND TREATMENT ***************************************
  if (message == WM_APPCOMMAND)
	{
    cmd = GET_APPCOMMAND_LPARAM(lParam);

    if (cmd == APPCOMMAND_MEDIA_PLAY_PAUSE)
    {
      ret = SendMessage(hwnd, WM_USER, 0, 104);
      if (ret == 1) SendMessage(hwnd, WM_COMMAND, 40046, 0);
      else SendMessage(hwnd, WM_COMMAND, 40045, 0);
      Result = TRUE;
    }
    if (cmd == APPCOMMAND_MEDIA_STOP) 
    { SendMessage(hwnd, WM_COMMAND, 40047, 0); Result = TRUE; }
    if (cmd == APPCOMMAND_MEDIA_NEXTTRACK) 
    { SendMessage(hwnd, WM_COMMAND, 40048, 0); Result = TRUE; }
    if (cmd == APPCOMMAND_MEDIA_PREVIOUSTRACK) 
    { SendMessage(hwnd, WM_COMMAND, 40044, 0); Result = TRUE; }

    if (cmd == APPCOMMAND_VOLUME_DOWN) 
    { SendMessage(hwnd, WM_COMMAND, 40059, 0); Result = TRUE; }
    //if (cmd == APPCOMMAND_VOLUME_MUTE)
    //{ SendMessage(hwnd, WM_COMMAND, 40047, 0); Result = TRUE; }
    if (cmd == APPCOMMAND_VOLUME_UP) 
    { SendMessage(hwnd, WM_COMMAND, 40058, 0); Result = TRUE; }
  }

	if (Result != TRUE) return CallWindowProc(lpWndProcOld,hwnd,message,wParam,lParam);
  else return Result;
}

int init()
{

  {
		static char c[512];
		char filename[512],*p;
		GetModuleFileName(plugin.hDllInstance,filename,sizeof(filename));
		p = filename+lstrlen(filename);
		while (p >= filename && *p != '\\') p--;
		wsprintf((plugin.description=c),"%s v%s (%s)",szAppName, DIMIN_VERSION, p+1);
	}

  lpWndProcOld = (void *) GetWindowLong(plugin.hwndParent,GWL_WNDPROC);
	SetWindowLong(plugin.hwndParent, GWL_WNDPROC, (long) WndProc);
  
  config_read();
  regAllHotKeys();

	return 0;
}

__declspec( dllexport ) winampGeneralPurposePlugin * winampGetGeneralPurposePlugin()
{
	return &plugin;
}

#undef uint



